/*
 * Module code.
 *
 * Generated by SIP 4.19.24
 */

#include "sipAPI_analysis.h"

#line 22 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/auto_generated/network/qgsgraphanalyzer.sip"
#include "qgsgraphanalyzer.h"
#line 12 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"

#line 118 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/auto_generated/network/qgsgraph.sip"
#include "qgsgraph.h"
#line 16 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 442 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qpycore_qvector.sip"
#include <qvector.h>
#line 19 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 241 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtGui/qpygui_qvector.sip"
#include <qvector.h>
#line 22 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"


PyDoc_STRVAR(doc_QgsGraphAnalyzer_dijkstra, "dijkstra(source: QgsGraph, startVertexIdx: int, criterionNum: int, resultTree: Iterable[int] = [], resultCost: Iterable[float] = []) -> List\n"
"Solve shortest path problem using Dijkstra algorithm\n"
"\n"
":param source: source graph\n"
":param startVertexIdx: index of the start vertex\n"
":param criterionNum: index of the optimization strategy\n"
":param resultTree: array that represents shortest path tree. resultTree[ vertexIndex ] == inboundingArcIndex if vertex reachable, otherwise resultTree[ vertexIndex ] == -1.\n"
"                   Note that the startVertexIdx will also have a value of -1 and may need special handling by callers.\n"
":param resultCost: array of the paths costs");

extern "C" {static PyObject *meth_QgsGraphAnalyzer_dijkstra(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_QgsGraphAnalyzer_dijkstra(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const  ::QgsGraph* a0;
        int a1;
        int a2;
         ::QVector<int>* a3 = 0;
        int a3State = 0;
         ::QVector< ::qreal>* a4 = 0;
        int a4State = 0;

        static const char *sipKwdList[] = {
            sipName_source,
            sipName_startVertexIdx,
            sipName_criterionNum,
            sipName_resultTree,
            sipName_resultCost,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "J8ii|J0J0", sipType_QgsGraph, &a0, &a1, &a2, sipType_QVector_1800,&a3, &a3State, sipType_QVector_2400,&a4, &a4State))
        {
            PyObject * sipRes = SIP_NULLPTR;

#line 39 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/auto_generated/network/qgsgraphanalyzer.sip"
    QVector< int > treeResult;
    QVector< double > costResult;
    QgsGraphAnalyzer::dijkstra( a0, a1, a2, &treeResult, &costResult );

    PyObject *l1 = PyList_New( treeResult.size() );
    if ( l1 == NULL )
    {
      return NULL;
    }
    PyObject *l2 = PyList_New( costResult.size() );
    if ( l2 == NULL )
    {
      return NULL;
    }
    int i;
    for ( i = 0; i < costResult.size(); ++i )
    {
      PyObject *Int = PyLong_FromLong( treeResult[i] );
      PyList_SET_ITEM( l1, i, Int );
      PyObject *Float = PyFloat_FromDouble( costResult[i] );
      PyList_SET_ITEM( l2, i, Float );
    }

    sipRes = PyTuple_New( 2 );
    PyTuple_SET_ITEM( sipRes, 0, l1 );
    PyTuple_SET_ITEM( sipRes, 1, l2 );
#line 89 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
            sipReleaseType(a3,sipType_QVector_1800,a3State);
            sipReleaseType(a4,sipType_QVector_2400,a4State);

            return sipRes;
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsGraphAnalyzer, sipName_dijkstra, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsGraphAnalyzer_shortestTree, "shortestTree(source: QgsGraph, startVertexIdx: int, criterionNum: int) -> QgsGraph\n"
"Returns shortest path tree with root-node in startVertexIdx\n"
"\n"
":param source: source graph\n"
":param startVertexIdx: index of the start vertex\n"
":param criterionNum: index of the optimization strategy");

extern "C" {static PyObject *meth_QgsGraphAnalyzer_shortestTree(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_QgsGraphAnalyzer_shortestTree(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const  ::QgsGraph* a0;
        int a1;
        int a2;

        static const char *sipKwdList[] = {
            sipName_source,
            sipName_startVertexIdx,
            sipName_criterionNum,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "J8ii", sipType_QgsGraph, &a0, &a1, &a2))
        {
             ::QgsGraph*sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes =  ::QgsGraphAnalyzer::shortestTree(a0,a1,a2);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_QgsGraph,SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsGraphAnalyzer, sipName_shortestTree, SIP_NULLPTR);

    return SIP_NULLPTR;
}


/* Call the instance's destructor. */
extern "C" {static void release_QgsGraphAnalyzer(void *, int);}
static void release_QgsGraphAnalyzer(void *sipCppV, int)
{
    Py_BEGIN_ALLOW_THREADS

    delete reinterpret_cast< ::QgsGraphAnalyzer *>(sipCppV);

    Py_END_ALLOW_THREADS
}


extern "C" {static void *array_QgsGraphAnalyzer(Py_ssize_t);}
static void *array_QgsGraphAnalyzer(Py_ssize_t sipNrElem)
{
    return new  ::QgsGraphAnalyzer[sipNrElem];
}


extern "C" {static void assign_QgsGraphAnalyzer(void *, SIP_SSIZE_T, void *);}
static void assign_QgsGraphAnalyzer(void *sipDst, SIP_SSIZE_T sipDstIdx, void *sipSrc)
{
    reinterpret_cast< ::QgsGraphAnalyzer *>(sipDst)[sipDstIdx] = *reinterpret_cast< ::QgsGraphAnalyzer *>(sipSrc);
}


extern "C" {static void *copy_QgsGraphAnalyzer(const void *, SIP_SSIZE_T);}
static void *copy_QgsGraphAnalyzer(const void *sipSrc, SIP_SSIZE_T sipSrcIdx)
{
    return new  ::QgsGraphAnalyzer(reinterpret_cast<const  ::QgsGraphAnalyzer *>(sipSrc)[sipSrcIdx]);
}


extern "C" {static void dealloc_QgsGraphAnalyzer(sipSimpleWrapper *);}
static void dealloc_QgsGraphAnalyzer(sipSimpleWrapper *sipSelf)
{
    if (sipIsOwnedByPython(sipSelf))
    {
        release_QgsGraphAnalyzer(sipGetAddress(sipSelf), 0);
    }
}


extern "C" {static void *init_type_QgsGraphAnalyzer(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_QgsGraphAnalyzer(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
     ::QgsGraphAnalyzer *sipCpp = SIP_NULLPTR;

    {
        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, SIP_NULLPTR, sipUnused, ""))
        {
            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipCpp = new  ::QgsGraphAnalyzer();
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipCpp;
        }
    }

    {
        const  ::QgsGraphAnalyzer* a0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, SIP_NULLPTR, sipUnused, "J9", sipType_QgsGraphAnalyzer, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipCpp = new  ::QgsGraphAnalyzer(*a0);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipCpp;
        }
    }

    return SIP_NULLPTR;
}


static PyMethodDef methods_QgsGraphAnalyzer[] = {
    {SIP_MLNAME_CAST(sipName_dijkstra), SIP_MLMETH_CAST(meth_QgsGraphAnalyzer_dijkstra), METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_QgsGraphAnalyzer_dijkstra)},
    {SIP_MLNAME_CAST(sipName_shortestTree), SIP_MLMETH_CAST(meth_QgsGraphAnalyzer_shortestTree), METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_QgsGraphAnalyzer_shortestTree)}
};

PyDoc_STRVAR(doc_QgsGraphAnalyzer, "This class performs graph analysis, e.g. calculates shortest path between two\n"
"points using different strategies with Dijkstra algorithm\n"
"\n"
"");


static pyqt5ClassPluginDef plugin_QgsGraphAnalyzer = {
    SIP_NULLPTR,
    0,
    SIP_NULLPTR,
    SIP_NULLPTR
};


sipClassTypeDef sipTypeDef__analysis_QgsGraphAnalyzer = {
    {
        -1,
        SIP_NULLPTR,
        SIP_NULLPTR,
        SIP_TYPE_SUPER_INIT|SIP_TYPE_CLASS,
        sipNameNr_QgsGraphAnalyzer,
        {SIP_NULLPTR},
        &plugin_QgsGraphAnalyzer
    },
    {
        sipNameNr_QgsGraphAnalyzer,
        {0, 0, 1},
        2, methods_QgsGraphAnalyzer,
        0, SIP_NULLPTR,
        0, SIP_NULLPTR,
        {SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR},
    },
    doc_QgsGraphAnalyzer,
    -1,
    -1,
    SIP_NULLPTR,
    SIP_NULLPTR,
    init_type_QgsGraphAnalyzer,
    SIP_NULLPTR,
    SIP_NULLPTR,
#if PY_MAJOR_VERSION >= 3
    SIP_NULLPTR,
    SIP_NULLPTR,
#else
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
#endif
    dealloc_QgsGraphAnalyzer,
    assign_QgsGraphAnalyzer,
    array_QgsGraphAnalyzer,
    copy_QgsGraphAnalyzer,
    release_QgsGraphAnalyzer,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR
};

#line 118 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/auto_generated/network/qgsgraph.sip"
#include "qgsgraph.h"
#line 321 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"

#line 44 "core/auto_generated/qgspointxy.sip"
#include "qgspointxy.h"
#line 325 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 23 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/auto_generated/network/qgsgraph.sip"
#include "qgsgraph.h"
#line 328 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 72 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/auto_generated/network/qgsgraph.sip"
#include "qgsgraph.h"
#line 331 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 28 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qpycore_qvector.sip"
#include <qvector.h>
#line 334 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 26 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qvariant.sip"
#include <qvariant.h>
#line 337 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"


PyDoc_STRVAR(doc_QgsGraph_addVertex, "addVertex(self, pt: QgsPointXY) -> int\n"
"Add a vertex to the graph");

extern "C" {static PyObject *meth_QgsGraph_addVertex(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_QgsGraph_addVertex(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const  ::QgsPointXY* a0;
         ::QgsGraph *sipCpp;

        static const char *sipKwdList[] = {
            sipName_pt,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "BJ9", &sipSelf, sipType_QgsGraph, &sipCpp, sipType_QgsPointXY, &a0))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = sipCpp->addVertex(*a0);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsGraph, sipName_addVertex, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsGraph_addEdge, "addEdge(self, fromVertexIdx: int, toVertexIdx: int, strategies: Iterable[Any]) -> int\n"
"Add an edge to the graph, going from the ``fromVertexIdx``\n"
"to ``toVertexIdx``.");

extern "C" {static PyObject *meth_QgsGraph_addEdge(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_QgsGraph_addEdge(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        int a0;
        int a1;
        const QVector< ::QVariant>* a2;
        int a2State = 0;
         ::QgsGraph *sipCpp;

        static const char *sipKwdList[] = {
            sipName_fromVertexIdx,
            sipName_toVertexIdx,
            sipName_strategies,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "BiiJ1", &sipSelf, sipType_QgsGraph, &sipCpp, &a0, &a1, sipType_QVector_0100QVariant,&a2, &a2State))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = sipCpp->addEdge(a0,a1,*a2);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

            sipReleaseType(const_cast<QVector< ::QVariant> *>(a2),sipType_QVector_0100QVariant,a2State);
                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QVector< ::QVariant> *>(a2),sipType_QVector_0100QVariant,a2State);

            return SIPLong_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsGraph, sipName_addEdge, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsGraph_vertexCount, "vertexCount(self) -> int\n"
"Returns number of graph vertices");

extern "C" {static PyObject *meth_QgsGraph_vertexCount(PyObject *, PyObject *);}
static PyObject *meth_QgsGraph_vertexCount(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const  ::QgsGraph *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_QgsGraph, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = sipCpp->vertexCount();
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsGraph, sipName_vertexCount, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsGraph_vertex, "vertex(self, idx: int) -> QgsGraphVertex\n"
"Returns vertex at given index");

extern "C" {static PyObject *meth_QgsGraph_vertex(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_QgsGraph_vertex(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        int a0;
        const  ::QgsGraph *sipCpp;

        static const char *sipKwdList[] = {
            sipName_idx,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "Bi", &sipSelf, sipType_QgsGraph, &sipCpp, &a0))
        {
             ::QgsGraphVertex*sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = new  ::QgsGraphVertex(sipCpp->vertex(a0));
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QgsGraphVertex,SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsGraph, sipName_vertex, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsGraph_edgeCount, "edgeCount(self) -> int\n"
"Returns number of graph edges");

extern "C" {static PyObject *meth_QgsGraph_edgeCount(PyObject *, PyObject *);}
static PyObject *meth_QgsGraph_edgeCount(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const  ::QgsGraph *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_QgsGraph, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = sipCpp->edgeCount();
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsGraph, sipName_edgeCount, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsGraph_edge, "edge(self, idx: int) -> QgsGraphEdge\n"
"Returns edge at given index");

extern "C" {static PyObject *meth_QgsGraph_edge(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_QgsGraph_edge(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        int a0;
        const  ::QgsGraph *sipCpp;

        static const char *sipKwdList[] = {
            sipName_idx,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "Bi", &sipSelf, sipType_QgsGraph, &sipCpp, &a0))
        {
             ::QgsGraphEdge*sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = new  ::QgsGraphEdge(sipCpp->edge(a0));
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QgsGraphEdge,SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsGraph, sipName_edge, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsGraph_findVertex, "findVertex(self, pt: QgsPointXY) -> int\n"
"Find vertex by associated point\n"
"\n"
":return: vertex index");

extern "C" {static PyObject *meth_QgsGraph_findVertex(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_QgsGraph_findVertex(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const  ::QgsPointXY* a0;
        const  ::QgsGraph *sipCpp;

        static const char *sipKwdList[] = {
            sipName_pt,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "BJ9", &sipSelf, sipType_QgsGraph, &sipCpp, sipType_QgsPointXY, &a0))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = sipCpp->findVertex(*a0);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsGraph, sipName_findVertex, SIP_NULLPTR);

    return SIP_NULLPTR;
}


/* Call the instance's destructor. */
extern "C" {static void release_QgsGraph(void *, int);}
static void release_QgsGraph(void *sipCppV, int)
{
    Py_BEGIN_ALLOW_THREADS

    delete reinterpret_cast< ::QgsGraph *>(sipCppV);

    Py_END_ALLOW_THREADS
}


extern "C" {static void *array_QgsGraph(Py_ssize_t);}
static void *array_QgsGraph(Py_ssize_t sipNrElem)
{
    return new  ::QgsGraph[sipNrElem];
}


extern "C" {static void assign_QgsGraph(void *, SIP_SSIZE_T, void *);}
static void assign_QgsGraph(void *sipDst, SIP_SSIZE_T sipDstIdx, void *sipSrc)
{
    reinterpret_cast< ::QgsGraph *>(sipDst)[sipDstIdx] = *reinterpret_cast< ::QgsGraph *>(sipSrc);
}


extern "C" {static void *copy_QgsGraph(const void *, SIP_SSIZE_T);}
static void *copy_QgsGraph(const void *sipSrc, SIP_SSIZE_T sipSrcIdx)
{
    return new  ::QgsGraph(reinterpret_cast<const  ::QgsGraph *>(sipSrc)[sipSrcIdx]);
}


extern "C" {static void dealloc_QgsGraph(sipSimpleWrapper *);}
static void dealloc_QgsGraph(sipSimpleWrapper *sipSelf)
{
    if (sipIsOwnedByPython(sipSelf))
    {
        release_QgsGraph(sipGetAddress(sipSelf), 0);
    }
}


extern "C" {static void *init_type_QgsGraph(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_QgsGraph(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
     ::QgsGraph *sipCpp = SIP_NULLPTR;

    {
        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, SIP_NULLPTR, sipUnused, ""))
        {
            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipCpp = new  ::QgsGraph();
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipCpp;
        }
    }

    {
        const  ::QgsGraph* a0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, SIP_NULLPTR, sipUnused, "J9", sipType_QgsGraph, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipCpp = new  ::QgsGraph(*a0);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipCpp;
        }
    }

    return SIP_NULLPTR;
}


static PyMethodDef methods_QgsGraph[] = {
    {SIP_MLNAME_CAST(sipName_addEdge), SIP_MLMETH_CAST(meth_QgsGraph_addEdge), METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_QgsGraph_addEdge)},
    {SIP_MLNAME_CAST(sipName_addVertex), SIP_MLMETH_CAST(meth_QgsGraph_addVertex), METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_QgsGraph_addVertex)},
    {SIP_MLNAME_CAST(sipName_edge), SIP_MLMETH_CAST(meth_QgsGraph_edge), METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_QgsGraph_edge)},
    {SIP_MLNAME_CAST(sipName_edgeCount), meth_QgsGraph_edgeCount, METH_VARARGS, SIP_MLDOC_CAST(doc_QgsGraph_edgeCount)},
    {SIP_MLNAME_CAST(sipName_findVertex), SIP_MLMETH_CAST(meth_QgsGraph_findVertex), METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_QgsGraph_findVertex)},
    {SIP_MLNAME_CAST(sipName_vertex), SIP_MLMETH_CAST(meth_QgsGraph_vertex), METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_QgsGraph_vertex)},
    {SIP_MLNAME_CAST(sipName_vertexCount), meth_QgsGraph_vertexCount, METH_VARARGS, SIP_MLDOC_CAST(doc_QgsGraph_vertexCount)}
};

PyDoc_STRVAR(doc_QgsGraph, "Mathematical graph representation\n"
"\n"
".. versionadded:: 3.0\n"
"\n"
"QgsGraph()\n"
"Constructor for QgsGraph.\n"
"\n"
"QgsGraph(QgsGraph)");


static pyqt5ClassPluginDef plugin_QgsGraph = {
    SIP_NULLPTR,
    0,
    SIP_NULLPTR,
    SIP_NULLPTR
};


sipClassTypeDef sipTypeDef__analysis_QgsGraph = {
    {
        -1,
        SIP_NULLPTR,
        SIP_NULLPTR,
        SIP_TYPE_SUPER_INIT|SIP_TYPE_CLASS,
        sipNameNr_QgsGraph,
        {SIP_NULLPTR},
        &plugin_QgsGraph
    },
    {
        sipNameNr_QgsGraph,
        {0, 0, 1},
        7, methods_QgsGraph,
        0, SIP_NULLPTR,
        0, SIP_NULLPTR,
        {SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR},
    },
    doc_QgsGraph,
    -1,
    -1,
    SIP_NULLPTR,
    SIP_NULLPTR,
    init_type_QgsGraph,
    SIP_NULLPTR,
    SIP_NULLPTR,
#if PY_MAJOR_VERSION >= 3
    SIP_NULLPTR,
    SIP_NULLPTR,
#else
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
#endif
    dealloc_QgsGraph,
    assign_QgsGraph,
    array_QgsGraph,
    copy_QgsGraph,
    release_QgsGraph,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR
};

#line 72 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/auto_generated/network/qgsgraph.sip"
#include "qgsgraph.h"
#line 832 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"

#line 44 "core/auto_generated/qgspointxy.sip"
#include "qgspointxy.h"
#line 836 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 646 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qpycore_qlist.sip"
#include <qlist.h>
#line 839 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"


PyDoc_STRVAR(doc_QgsGraphVertex_incomingEdges, "incomingEdges(self) -> List[int]\n"
"Returns the incoming edge ids, i.e. edges which end at this node.\n"
"\n"
".. seealso:: :py:func:`outgoingEdges`");

extern "C" {static PyObject *meth_QgsGraphVertex_incomingEdges(PyObject *, PyObject *);}
static PyObject *meth_QgsGraphVertex_incomingEdges(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const  ::QgsGraphVertex *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_QgsGraphVertex, &sipCpp))
        {
             ::QgsGraphEdgeIds*sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = new  ::QgsGraphEdgeIds(sipCpp->incomingEdges());
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QList_1800,SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsGraphVertex, sipName_incomingEdges, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsGraphVertex_outgoingEdges, "outgoingEdges(self) -> List[int]\n"
"Returns outgoing edge ids, i.e. edges which start at this node.\n"
"\n"
".. seealso:: :py:func:`incomingEdges`");

extern "C" {static PyObject *meth_QgsGraphVertex_outgoingEdges(PyObject *, PyObject *);}
static PyObject *meth_QgsGraphVertex_outgoingEdges(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const  ::QgsGraphVertex *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_QgsGraphVertex, &sipCpp))
        {
             ::QgsGraphEdgeIds*sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = new  ::QgsGraphEdgeIds(sipCpp->outgoingEdges());
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QList_1800,SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsGraphVertex, sipName_outgoingEdges, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsGraphVertex_point, "point(self) -> QgsPointXY\n"
"Returns point associated with graph vertex.");

extern "C" {static PyObject *meth_QgsGraphVertex_point(PyObject *, PyObject *);}
static PyObject *meth_QgsGraphVertex_point(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const  ::QgsGraphVertex *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_QgsGraphVertex, &sipCpp))
        {
             ::QgsPointXY*sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = new  ::QgsPointXY(sipCpp->point());
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QgsPointXY,SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsGraphVertex, sipName_point, SIP_NULLPTR);

    return SIP_NULLPTR;
}


/* Call the instance's destructor. */
extern "C" {static void release_QgsGraphVertex(void *, int);}
static void release_QgsGraphVertex(void *sipCppV, int)
{
    Py_BEGIN_ALLOW_THREADS

    delete reinterpret_cast< ::QgsGraphVertex *>(sipCppV);

    Py_END_ALLOW_THREADS
}


extern "C" {static void *array_QgsGraphVertex(Py_ssize_t);}
static void *array_QgsGraphVertex(Py_ssize_t sipNrElem)
{
    return new  ::QgsGraphVertex[sipNrElem];
}


extern "C" {static void assign_QgsGraphVertex(void *, SIP_SSIZE_T, void *);}
static void assign_QgsGraphVertex(void *sipDst, SIP_SSIZE_T sipDstIdx, void *sipSrc)
{
    reinterpret_cast< ::QgsGraphVertex *>(sipDst)[sipDstIdx] = *reinterpret_cast< ::QgsGraphVertex *>(sipSrc);
}


extern "C" {static void *copy_QgsGraphVertex(const void *, SIP_SSIZE_T);}
static void *copy_QgsGraphVertex(const void *sipSrc, SIP_SSIZE_T sipSrcIdx)
{
    return new  ::QgsGraphVertex(reinterpret_cast<const  ::QgsGraphVertex *>(sipSrc)[sipSrcIdx]);
}


extern "C" {static void dealloc_QgsGraphVertex(sipSimpleWrapper *);}
static void dealloc_QgsGraphVertex(sipSimpleWrapper *sipSelf)
{
    if (sipIsOwnedByPython(sipSelf))
    {
        release_QgsGraphVertex(sipGetAddress(sipSelf), 0);
    }
}


extern "C" {static void *init_type_QgsGraphVertex(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_QgsGraphVertex(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
     ::QgsGraphVertex *sipCpp = SIP_NULLPTR;

    {
        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, SIP_NULLPTR, sipUnused, ""))
        {
            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipCpp = new  ::QgsGraphVertex();
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipCpp;
        }
    }

    {
        const  ::QgsPointXY* a0;

        static const char *sipKwdList[] = {
            sipName_point,
        };

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, sipKwdList, sipUnused, "J9", sipType_QgsPointXY, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipCpp = new  ::QgsGraphVertex(*a0);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipCpp;
        }
    }

    {
        const  ::QgsGraphVertex* a0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, SIP_NULLPTR, sipUnused, "J9", sipType_QgsGraphVertex, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipCpp = new  ::QgsGraphVertex(*a0);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipCpp;
        }
    }

    return SIP_NULLPTR;
}


static PyMethodDef methods_QgsGraphVertex[] = {
    {SIP_MLNAME_CAST(sipName_incomingEdges), meth_QgsGraphVertex_incomingEdges, METH_VARARGS, SIP_MLDOC_CAST(doc_QgsGraphVertex_incomingEdges)},
    {SIP_MLNAME_CAST(sipName_outgoingEdges), meth_QgsGraphVertex_outgoingEdges, METH_VARARGS, SIP_MLDOC_CAST(doc_QgsGraphVertex_outgoingEdges)},
    {SIP_MLNAME_CAST(sipName_point), meth_QgsGraphVertex_point, METH_VARARGS, SIP_MLDOC_CAST(doc_QgsGraphVertex_point)}
};

PyDoc_STRVAR(doc_QgsGraphVertex, "This class implements a graph vertex\n"
"\n"
".. versionadded:: 3.0\n"
"\n"
"QgsGraphVertex()\n"
"Default constructor. It is needed for Qt's container, e.g. QVector\n"
"\n"
"QgsGraphVertex(point: QgsPointXY)\n"
"This constructor initializes QgsGraphVertex object and associates a vertex with a point\n"
"\n"
"QgsGraphVertex(QgsGraphVertex)");


static pyqt5ClassPluginDef plugin_QgsGraphVertex = {
    SIP_NULLPTR,
    0,
    SIP_NULLPTR,
    SIP_NULLPTR
};


sipClassTypeDef sipTypeDef__analysis_QgsGraphVertex = {
    {
        -1,
        SIP_NULLPTR,
        SIP_NULLPTR,
        SIP_TYPE_SUPER_INIT|SIP_TYPE_CLASS,
        sipNameNr_QgsGraphVertex,
        {SIP_NULLPTR},
        &plugin_QgsGraphVertex
    },
    {
        sipNameNr_QgsGraphVertex,
        {0, 0, 1},
        3, methods_QgsGraphVertex,
        0, SIP_NULLPTR,
        0, SIP_NULLPTR,
        {SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR},
    },
    doc_QgsGraphVertex,
    -1,
    -1,
    SIP_NULLPTR,
    SIP_NULLPTR,
    init_type_QgsGraphVertex,
    SIP_NULLPTR,
    SIP_NULLPTR,
#if PY_MAJOR_VERSION >= 3
    SIP_NULLPTR,
    SIP_NULLPTR,
#else
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
#endif
    dealloc_QgsGraphVertex,
    assign_QgsGraphVertex,
    array_QgsGraphVertex,
    copy_QgsGraphVertex,
    release_QgsGraphVertex,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR
};

#line 23 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/auto_generated/network/qgsgraph.sip"
#include "qgsgraph.h"
#line 1170 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"

#line 28 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qpycore_qvector.sip"
#include <qvector.h>
#line 1174 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 26 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qvariant.sip"
#include <qvariant.h>
#line 1177 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"


PyDoc_STRVAR(doc_QgsGraphEdge_cost, "cost(self, strategyIndex: int) -> Any\n"
"Returns edge cost calculated using specified strategy\n"
"\n"
":param strategyIndex: strategy index");

extern "C" {static PyObject *meth_QgsGraphEdge_cost(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_QgsGraphEdge_cost(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        int a0;
        const  ::QgsGraphEdge *sipCpp;

        static const char *sipKwdList[] = {
            sipName_strategyIndex,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "Bi", &sipSelf, sipType_QgsGraphEdge, &sipCpp, &a0))
        {
             ::QVariant*sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = new  ::QVariant(sipCpp->cost(a0));
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QVariant,SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsGraphEdge, sipName_cost, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsGraphEdge_strategies, "strategies(self) -> List[Any]\n"
"Returns array of available strategies");

extern "C" {static PyObject *meth_QgsGraphEdge_strategies(PyObject *, PyObject *);}
static PyObject *meth_QgsGraphEdge_strategies(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const  ::QgsGraphEdge *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_QgsGraphEdge, &sipCpp))
        {
            QVector< ::QVariant>*sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = new QVector< ::QVariant>(sipCpp->strategies());
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QVector_0100QVariant,SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsGraphEdge, sipName_strategies, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsGraphEdge_toVertex, "toVertex(self) -> int\n"
"Returns the index of the vertex at the end of this edge.\n"
"\n"
".. seealso:: :py:func:`fromVertex`");

extern "C" {static PyObject *meth_QgsGraphEdge_toVertex(PyObject *, PyObject *);}
static PyObject *meth_QgsGraphEdge_toVertex(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const  ::QgsGraphEdge *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_QgsGraphEdge, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = sipCpp->toVertex();
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsGraphEdge, sipName_toVertex, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsGraphEdge_fromVertex, "fromVertex(self) -> int\n"
"Returns the index of the vertex at the start of this edge.\n"
"\n"
".. seealso:: :py:func:`toVertex`");

extern "C" {static PyObject *meth_QgsGraphEdge_fromVertex(PyObject *, PyObject *);}
static PyObject *meth_QgsGraphEdge_fromVertex(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const  ::QgsGraphEdge *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_QgsGraphEdge, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = sipCpp->fromVertex();
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsGraphEdge, sipName_fromVertex, SIP_NULLPTR);

    return SIP_NULLPTR;
}


/* Call the instance's destructor. */
extern "C" {static void release_QgsGraphEdge(void *, int);}
static void release_QgsGraphEdge(void *sipCppV, int)
{
    Py_BEGIN_ALLOW_THREADS

    delete reinterpret_cast< ::QgsGraphEdge *>(sipCppV);

    Py_END_ALLOW_THREADS
}


extern "C" {static void *array_QgsGraphEdge(Py_ssize_t);}
static void *array_QgsGraphEdge(Py_ssize_t sipNrElem)
{
    return new  ::QgsGraphEdge[sipNrElem];
}


extern "C" {static void assign_QgsGraphEdge(void *, SIP_SSIZE_T, void *);}
static void assign_QgsGraphEdge(void *sipDst, SIP_SSIZE_T sipDstIdx, void *sipSrc)
{
    reinterpret_cast< ::QgsGraphEdge *>(sipDst)[sipDstIdx] = *reinterpret_cast< ::QgsGraphEdge *>(sipSrc);
}


extern "C" {static void *copy_QgsGraphEdge(const void *, SIP_SSIZE_T);}
static void *copy_QgsGraphEdge(const void *sipSrc, SIP_SSIZE_T sipSrcIdx)
{
    return new  ::QgsGraphEdge(reinterpret_cast<const  ::QgsGraphEdge *>(sipSrc)[sipSrcIdx]);
}


extern "C" {static void dealloc_QgsGraphEdge(sipSimpleWrapper *);}
static void dealloc_QgsGraphEdge(sipSimpleWrapper *sipSelf)
{
    if (sipIsOwnedByPython(sipSelf))
    {
        release_QgsGraphEdge(sipGetAddress(sipSelf), 0);
    }
}


extern "C" {static void *init_type_QgsGraphEdge(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_QgsGraphEdge(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
     ::QgsGraphEdge *sipCpp = SIP_NULLPTR;

    {
        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, SIP_NULLPTR, sipUnused, ""))
        {
            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipCpp = new  ::QgsGraphEdge();
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipCpp;
        }
    }

    {
        const  ::QgsGraphEdge* a0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, SIP_NULLPTR, sipUnused, "J9", sipType_QgsGraphEdge, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipCpp = new  ::QgsGraphEdge(*a0);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipCpp;
        }
    }

    return SIP_NULLPTR;
}


static PyMethodDef methods_QgsGraphEdge[] = {
    {SIP_MLNAME_CAST(sipName_cost), SIP_MLMETH_CAST(meth_QgsGraphEdge_cost), METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_QgsGraphEdge_cost)},
    {SIP_MLNAME_CAST(sipName_fromVertex), meth_QgsGraphEdge_fromVertex, METH_VARARGS, SIP_MLDOC_CAST(doc_QgsGraphEdge_fromVertex)},
    {SIP_MLNAME_CAST(sipName_strategies), meth_QgsGraphEdge_strategies, METH_VARARGS, SIP_MLDOC_CAST(doc_QgsGraphEdge_strategies)},
    {SIP_MLNAME_CAST(sipName_toVertex), meth_QgsGraphEdge_toVertex, METH_VARARGS, SIP_MLDOC_CAST(doc_QgsGraphEdge_toVertex)}
};

PyDoc_STRVAR(doc_QgsGraphEdge, "This class implements a graph edge\n"
"\n"
".. versionadded:: 3.0\n"
"\n"
"QgsGraphEdge()\n"
"Constructor for QgsGraphEdge.\n"
"\n"
"QgsGraphEdge(QgsGraphEdge)");


static pyqt5ClassPluginDef plugin_QgsGraphEdge = {
    SIP_NULLPTR,
    0,
    SIP_NULLPTR,
    SIP_NULLPTR
};


sipClassTypeDef sipTypeDef__analysis_QgsGraphEdge = {
    {
        -1,
        SIP_NULLPTR,
        SIP_NULLPTR,
        SIP_TYPE_SUPER_INIT|SIP_TYPE_CLASS,
        sipNameNr_QgsGraphEdge,
        {SIP_NULLPTR},
        &plugin_QgsGraphEdge
    },
    {
        sipNameNr_QgsGraphEdge,
        {0, 0, 1},
        4, methods_QgsGraphEdge,
        0, SIP_NULLPTR,
        0, SIP_NULLPTR,
        {SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR},
    },
    doc_QgsGraphEdge,
    -1,
    -1,
    SIP_NULLPTR,
    SIP_NULLPTR,
    init_type_QgsGraphEdge,
    SIP_NULLPTR,
    SIP_NULLPTR,
#if PY_MAJOR_VERSION >= 3
    SIP_NULLPTR,
    SIP_NULLPTR,
#else
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
#endif
    dealloc_QgsGraphEdge,
    assign_QgsGraphEdge,
    array_QgsGraphEdge,
    copy_QgsGraphEdge,
    release_QgsGraphEdge,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR
};

#line 86 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/auto_generated/mesh/qgsmeshtriangulation.sip"
#include "qgsmeshtriangulation.h"
#line 1525 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"

#line 27 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qstring.sip"
#include <qstring.h>
#line 1529 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 312 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtXml/qdom.sip"
#include <qdom.h>
#line 1532 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 192 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtXml/qdom.sip"
#include <qdom.h>
#line 1535 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 22 "core/auto_generated/qgsreadwritecontext.sip"
#include "qgsreadwritecontext.h"
#line 1538 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 620 "core/auto_generated/mesh/qgsmeshdataset.sip"
#include "qgsmeshdataset.h"
#line 1541 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 569 "core/auto_generated/mesh/qgsmeshdataset.sip"
#include "qgsmeshdataset.h"
#line 1544 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 505 "core/auto_generated/mesh/qgsmeshdataset.sip"
#include "qgsmeshdataset.h"
#line 1547 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 360 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qdatetime.sip"
#include <qdatetime.h>
#line 1550 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 36 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qstringlist.sip"
#include <qstringlist.h>
#line 1553 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 27 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qpycore_qmap.sip"
#include <qmap.h>
#line 1556 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 383 "core/auto_generated/mesh/qgsmeshdataset.sip"
#include "qgsmeshdataset.h"
#line 1559 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"


class sipQgsMeshZValueDatasetGroup : public  ::QgsMeshZValueDatasetGroup
{
public:
    sipQgsMeshZValueDatasetGroup(const  ::QString&,const  ::QgsMesh&);
    virtual ~sipQgsMeshZValueDatasetGroup();

    /*
     * There is a protected method for every virtual method visible from
     * this class.
     */
protected:
    void initialize() SIP_OVERRIDE;
     ::QgsMeshDatasetMetadata datasetMetadata(int) const SIP_OVERRIDE;
    int datasetCount() const SIP_OVERRIDE;
     ::QgsMeshDataset* dataset(int) const SIP_OVERRIDE;
     ::QgsMeshDatasetGroup::Type type() const SIP_OVERRIDE;
     ::QStringList datasetGroupNamesDependentOn() const SIP_OVERRIDE;
     ::QDomElement writeXml( ::QDomDocument&,const  ::QgsReadWriteContext&) const SIP_OVERRIDE;
     ::QString description() const SIP_OVERRIDE;

public:
    sipSimpleWrapper *sipPySelf;

private:
    sipQgsMeshZValueDatasetGroup(const sipQgsMeshZValueDatasetGroup &);
    sipQgsMeshZValueDatasetGroup &operator = (const sipQgsMeshZValueDatasetGroup &);

    char sipPyMethods[8];
};

sipQgsMeshZValueDatasetGroup::sipQgsMeshZValueDatasetGroup(const  ::QString& a0,const  ::QgsMesh& a1):  ::QgsMeshZValueDatasetGroup(a0,a1), sipPySelf(SIP_NULLPTR)
{
    memset(sipPyMethods, 0, sizeof (sipPyMethods));
}

sipQgsMeshZValueDatasetGroup::~sipQgsMeshZValueDatasetGroup()
{
    sipInstanceDestroyedEx(&sipPySelf);
}

void sipQgsMeshZValueDatasetGroup::initialize()
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[0],sipPySelf,SIP_NULLPTR,sipName_initialize);

    if (!sipMeth)
    {
         ::QgsMeshZValueDatasetGroup::initialize();
        return;
    }

    extern void sipVH__analysis_18(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *);

    sipVH__analysis_18(sipGILState, sipImportedVirtErrorHandlers__analysis_QtCore[0].iveh_handler, sipPySelf, sipMeth);
}

 ::QgsMeshDatasetMetadata sipQgsMeshZValueDatasetGroup::datasetMetadata(int a0) const
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,const_cast<char *>(&sipPyMethods[1]),sipPySelf,SIP_NULLPTR,sipName_datasetMetadata);

    if (!sipMeth)
        return  ::QgsMeshZValueDatasetGroup::datasetMetadata(a0);

    extern  ::QgsMeshDatasetMetadata sipVH__analysis_17(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *, int);

    return sipVH__analysis_17(sipGILState, sipImportedVirtErrorHandlers__analysis_QtCore[0].iveh_handler, sipPySelf, sipMeth, a0);
}

int sipQgsMeshZValueDatasetGroup::datasetCount() const
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,const_cast<char *>(&sipPyMethods[2]),sipPySelf,SIP_NULLPTR,sipName_datasetCount);

    if (!sipMeth)
        return  ::QgsMeshZValueDatasetGroup::datasetCount();

    extern int sipVH__analysis_3(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *);

    return sipVH__analysis_3(sipGILState, sipImportedVirtErrorHandlers__analysis_QtCore[0].iveh_handler, sipPySelf, sipMeth);
}

 ::QgsMeshDataset* sipQgsMeshZValueDatasetGroup::dataset(int a0) const
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,const_cast<char *>(&sipPyMethods[3]),sipPySelf,SIP_NULLPTR,sipName_dataset);

    if (!sipMeth)
        return  ::QgsMeshZValueDatasetGroup::dataset(a0);

    extern  ::QgsMeshDataset* sipVH__analysis_16(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *, int);

    return sipVH__analysis_16(sipGILState, sipImportedVirtErrorHandlers__analysis_QtCore[0].iveh_handler, sipPySelf, sipMeth, a0);
}

 ::QgsMeshDatasetGroup::Type sipQgsMeshZValueDatasetGroup::type() const
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,const_cast<char *>(&sipPyMethods[4]),sipPySelf,SIP_NULLPTR,sipName_type);

    if (!sipMeth)
        return  ::QgsMeshZValueDatasetGroup::type();

    extern  ::QgsMeshDatasetGroup::Type sipVH__analysis_15(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *);

    return sipVH__analysis_15(sipGILState, sipImportedVirtErrorHandlers__analysis_QtCore[0].iveh_handler, sipPySelf, sipMeth);
}

 ::QStringList sipQgsMeshZValueDatasetGroup::datasetGroupNamesDependentOn() const
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,const_cast<char *>(&sipPyMethods[5]),sipPySelf,SIP_NULLPTR,sipName_datasetGroupNamesDependentOn);

    if (!sipMeth)
        return  ::QgsMeshZValueDatasetGroup::datasetGroupNamesDependentOn();

    extern  ::QStringList sipVH__analysis_14(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *);

    return sipVH__analysis_14(sipGILState, sipImportedVirtErrorHandlers__analysis_QtCore[0].iveh_handler, sipPySelf, sipMeth);
}

 ::QDomElement sipQgsMeshZValueDatasetGroup::writeXml( ::QDomDocument& a0,const  ::QgsReadWriteContext& a1) const
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,const_cast<char *>(&sipPyMethods[6]),sipPySelf,SIP_NULLPTR,sipName_writeXml);

    if (!sipMeth)
        return  ::QgsMeshZValueDatasetGroup::writeXml(a0,a1);

    extern  ::QDomElement sipVH__analysis_13(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *,  ::QDomDocument&,const  ::QgsReadWriteContext&);

    return sipVH__analysis_13(sipGILState, sipImportedVirtErrorHandlers__analysis_QtCore[0].iveh_handler, sipPySelf, sipMeth, a0, a1);
}

 ::QString sipQgsMeshZValueDatasetGroup::description() const
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,const_cast<char *>(&sipPyMethods[7]),sipPySelf,SIP_NULLPTR,sipName_description);

    if (!sipMeth)
        return  ::QgsMeshZValueDatasetGroup::description();

    extern  ::QString sipVH__analysis_12(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *);

    return sipVH__analysis_12(sipGILState, sipImportedVirtErrorHandlers__analysis_QtCore[0].iveh_handler, sipPySelf, sipMeth);
}


PyDoc_STRVAR(doc_QgsMeshZValueDatasetGroup_initialize, "initialize(self)");

extern "C" {static PyObject *meth_QgsMeshZValueDatasetGroup_initialize(PyObject *, PyObject *);}
static PyObject *meth_QgsMeshZValueDatasetGroup_initialize(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;
    bool sipSelfWasArg = (!sipSelf || sipIsDerivedClass((sipSimpleWrapper *)sipSelf));

    {
         ::QgsMeshZValueDatasetGroup *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_QgsMeshZValueDatasetGroup, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            try
            {
            (sipSelfWasArg ? sipCpp-> ::QgsMeshZValueDatasetGroup::initialize() : sipCpp->initialize());
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshZValueDatasetGroup, sipName_initialize, doc_QgsMeshZValueDatasetGroup_initialize);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsMeshZValueDatasetGroup_datasetMetadata, "datasetMetadata(self, datasetIndex: int) -> QgsMeshDatasetMetadata");

extern "C" {static PyObject *meth_QgsMeshZValueDatasetGroup_datasetMetadata(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_QgsMeshZValueDatasetGroup_datasetMetadata(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;
    bool sipSelfWasArg = (!sipSelf || sipIsDerivedClass((sipSimpleWrapper *)sipSelf));

    {
        int a0;
        const  ::QgsMeshZValueDatasetGroup *sipCpp;

        static const char *sipKwdList[] = {
            sipName_datasetIndex,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "Bi", &sipSelf, sipType_QgsMeshZValueDatasetGroup, &sipCpp, &a0))
        {
             ::QgsMeshDatasetMetadata*sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = new  ::QgsMeshDatasetMetadata((sipSelfWasArg ? sipCpp-> ::QgsMeshZValueDatasetGroup::datasetMetadata(a0) : sipCpp->datasetMetadata(a0)));
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QgsMeshDatasetMetadata,SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshZValueDatasetGroup, sipName_datasetMetadata, doc_QgsMeshZValueDatasetGroup_datasetMetadata);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsMeshZValueDatasetGroup_datasetCount, "datasetCount(self) -> int");

extern "C" {static PyObject *meth_QgsMeshZValueDatasetGroup_datasetCount(PyObject *, PyObject *);}
static PyObject *meth_QgsMeshZValueDatasetGroup_datasetCount(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;
    bool sipSelfWasArg = (!sipSelf || sipIsDerivedClass((sipSimpleWrapper *)sipSelf));

    {
        const  ::QgsMeshZValueDatasetGroup *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_QgsMeshZValueDatasetGroup, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = (sipSelfWasArg ? sipCpp-> ::QgsMeshZValueDatasetGroup::datasetCount() : sipCpp->datasetCount());
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshZValueDatasetGroup, sipName_datasetCount, doc_QgsMeshZValueDatasetGroup_datasetCount);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsMeshZValueDatasetGroup_dataset, "dataset(self, index: int) -> QgsMeshDataset");

extern "C" {static PyObject *meth_QgsMeshZValueDatasetGroup_dataset(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_QgsMeshZValueDatasetGroup_dataset(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;
    bool sipSelfWasArg = (!sipSelf || sipIsDerivedClass((sipSimpleWrapper *)sipSelf));

    {
        int a0;
        const  ::QgsMeshZValueDatasetGroup *sipCpp;

        static const char *sipKwdList[] = {
            sipName_index,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "Bi", &sipSelf, sipType_QgsMeshZValueDatasetGroup, &sipCpp, &a0))
        {
             ::QgsMeshDataset*sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = (sipSelfWasArg ? sipCpp-> ::QgsMeshZValueDatasetGroup::dataset(a0) : sipCpp->dataset(a0));
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_QgsMeshDataset,SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshZValueDatasetGroup, sipName_dataset, doc_QgsMeshZValueDatasetGroup_dataset);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsMeshZValueDatasetGroup_type, "type(self) -> QgsMeshDatasetGroup.Type");

extern "C" {static PyObject *meth_QgsMeshZValueDatasetGroup_type(PyObject *, PyObject *);}
static PyObject *meth_QgsMeshZValueDatasetGroup_type(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;
    bool sipSelfWasArg = (!sipSelf || sipIsDerivedClass((sipSimpleWrapper *)sipSelf));

    {
        const  ::QgsMeshZValueDatasetGroup *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_QgsMeshZValueDatasetGroup, &sipCpp))
        {
             ::QgsMeshDatasetGroup::Type sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = (sipSelfWasArg ? sipCpp-> ::QgsMeshZValueDatasetGroup::type() : sipCpp->type());
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipConvertFromEnum(static_cast<int>(sipRes), sipType_QgsMeshDatasetGroup_Type);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshZValueDatasetGroup, sipName_type, doc_QgsMeshZValueDatasetGroup_type);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsMeshZValueDatasetGroup_writeXml, "writeXml(self, doc: QDomDocument, context: QgsReadWriteContext) -> QDomElement");

extern "C" {static PyObject *meth_QgsMeshZValueDatasetGroup_writeXml(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_QgsMeshZValueDatasetGroup_writeXml(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;
    bool sipSelfWasArg = (!sipSelf || sipIsDerivedClass((sipSimpleWrapper *)sipSelf));

    {
         ::QDomDocument* a0;
        const  ::QgsReadWriteContext* a1;
        const  ::QgsMeshZValueDatasetGroup *sipCpp;

        static const char *sipKwdList[] = {
            sipName_doc,
            sipName_context,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "BJ9J9", &sipSelf, sipType_QgsMeshZValueDatasetGroup, &sipCpp, sipType_QDomDocument, &a0, sipType_QgsReadWriteContext, &a1))
        {
             ::QDomElement*sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = new  ::QDomElement((sipSelfWasArg ? sipCpp-> ::QgsMeshZValueDatasetGroup::writeXml(*a0,*a1) : sipCpp->writeXml(*a0,*a1)));
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QDomElement,SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshZValueDatasetGroup, sipName_writeXml, doc_QgsMeshZValueDatasetGroup_writeXml);

    return SIP_NULLPTR;
}


/* Cast a pointer to a type somewhere in its inheritance hierarchy. */
extern "C" {static void *cast_QgsMeshZValueDatasetGroup(void *, const sipTypeDef *);}
static void *cast_QgsMeshZValueDatasetGroup(void *sipCppV, const sipTypeDef *targetType)
{
     ::QgsMeshZValueDatasetGroup *sipCpp = reinterpret_cast< ::QgsMeshZValueDatasetGroup *>(sipCppV);

    if (targetType == sipType_QgsMeshDatasetGroup)
        return static_cast< ::QgsMeshDatasetGroup *>(sipCpp);

    return sipCppV;
}


/* Call the instance's destructor. */
extern "C" {static void release_QgsMeshZValueDatasetGroup(void *, int);}
static void release_QgsMeshZValueDatasetGroup(void *sipCppV, int sipState)
{
    Py_BEGIN_ALLOW_THREADS

    if (sipState & SIP_DERIVED_CLASS)
        delete reinterpret_cast<sipQgsMeshZValueDatasetGroup *>(sipCppV);
    else
        delete reinterpret_cast< ::QgsMeshZValueDatasetGroup *>(sipCppV);

    Py_END_ALLOW_THREADS
}


extern "C" {static void dealloc_QgsMeshZValueDatasetGroup(sipSimpleWrapper *);}
static void dealloc_QgsMeshZValueDatasetGroup(sipSimpleWrapper *sipSelf)
{
    if (sipIsDerivedClass(sipSelf))
        reinterpret_cast<sipQgsMeshZValueDatasetGroup *>(sipGetAddress(sipSelf))->sipPySelf = SIP_NULLPTR;

    if (sipIsOwnedByPython(sipSelf))
    {
        release_QgsMeshZValueDatasetGroup(sipGetAddress(sipSelf), sipIsDerivedClass(sipSelf));
    }
}


extern "C" {static void *init_type_QgsMeshZValueDatasetGroup(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_QgsMeshZValueDatasetGroup(sipSimpleWrapper *sipSelf, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    sipQgsMeshZValueDatasetGroup *sipCpp = SIP_NULLPTR;

    {
        const  ::QString* a0;
        int a0State = 0;
        const  ::QgsMesh* a1;

        static const char *sipKwdList[] = {
            sipName_datasetGroupName,
            sipName_mesh,
        };

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, sipKwdList, sipUnused, "J1J9", sipType_QString,&a0, &a0State, sipType_QgsMesh, &a1))
        {
            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipCpp = new sipQgsMeshZValueDatasetGroup(*a0,*a1);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

            sipReleaseType(const_cast< ::QString *>(a0),sipType_QString,a0State);
                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast< ::QString *>(a0),sipType_QString,a0State);

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    return SIP_NULLPTR;
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_QgsMeshZValueDatasetGroup[] = {{28, 7, 1}};


static PyMethodDef methods_QgsMeshZValueDatasetGroup[] = {
    {SIP_MLNAME_CAST(sipName_dataset), SIP_MLMETH_CAST(meth_QgsMeshZValueDatasetGroup_dataset), METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_QgsMeshZValueDatasetGroup_dataset)},
    {SIP_MLNAME_CAST(sipName_datasetCount), meth_QgsMeshZValueDatasetGroup_datasetCount, METH_VARARGS, SIP_MLDOC_CAST(doc_QgsMeshZValueDatasetGroup_datasetCount)},
    {SIP_MLNAME_CAST(sipName_datasetMetadata), SIP_MLMETH_CAST(meth_QgsMeshZValueDatasetGroup_datasetMetadata), METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_QgsMeshZValueDatasetGroup_datasetMetadata)},
    {SIP_MLNAME_CAST(sipName_initialize), meth_QgsMeshZValueDatasetGroup_initialize, METH_VARARGS, SIP_MLDOC_CAST(doc_QgsMeshZValueDatasetGroup_initialize)},
    {SIP_MLNAME_CAST(sipName_type), meth_QgsMeshZValueDatasetGroup_type, METH_VARARGS, SIP_MLDOC_CAST(doc_QgsMeshZValueDatasetGroup_type)},
    {SIP_MLNAME_CAST(sipName_writeXml), SIP_MLMETH_CAST(meth_QgsMeshZValueDatasetGroup_writeXml), METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_QgsMeshZValueDatasetGroup_writeXml)}
};

PyDoc_STRVAR(doc_QgsMeshZValueDatasetGroup, "\n"
"Convenient class that can be used to obtain a datasetgroup on vertices that represents the Z value of the mesh vertices\n"
"\n"
".. versionadded:: 3.16\n"
"\n"
"QgsMeshZValueDatasetGroup(datasetGroupName: str, mesh: QgsMesh)\n"
"Constructor\n"
"\n"
":param datasetGroupName: the name of the dataset group\n"
":param mesh: the mesh used to create the Z value dataset");


static pyqt5ClassPluginDef plugin_QgsMeshZValueDatasetGroup = {
    SIP_NULLPTR,
    0,
    SIP_NULLPTR,
    SIP_NULLPTR
};


sipClassTypeDef sipTypeDef__analysis_QgsMeshZValueDatasetGroup = {
    {
        -1,
        SIP_NULLPTR,
        SIP_NULLPTR,
        SIP_TYPE_SUPER_INIT|SIP_TYPE_CLASS,
        sipNameNr_QgsMeshZValueDatasetGroup,
        {SIP_NULLPTR},
        &plugin_QgsMeshZValueDatasetGroup
    },
    {
        sipNameNr_QgsMeshZValueDatasetGroup,
        {0, 0, 1},
        6, methods_QgsMeshZValueDatasetGroup,
        0, SIP_NULLPTR,
        0, SIP_NULLPTR,
        {SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR},
    },
    doc_QgsMeshZValueDatasetGroup,
    -1,
    -1,
    supers_QgsMeshZValueDatasetGroup,
    SIP_NULLPTR,
    init_type_QgsMeshZValueDatasetGroup,
    SIP_NULLPTR,
    SIP_NULLPTR,
#if PY_MAJOR_VERSION >= 3
    SIP_NULLPTR,
    SIP_NULLPTR,
#else
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
#endif
    dealloc_QgsMeshZValueDatasetGroup,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    release_QgsMeshZValueDatasetGroup,
    cast_QgsMeshZValueDatasetGroup,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR
};

#line 24 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/auto_generated/mesh/qgsmeshtriangulation.sip"
#include "qgsmeshtriangulation.h"
#line 2151 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"

#line 178 "core/auto_generated/proj/qgscoordinatereferencesystem.sip"
#include "qgscoordinatereferencesystem.h"
#line 2155 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 35 "core/auto_generated/qgsfeedback.sip"
#include "qgsfeedback.h"
#line 2158 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 201 "core/auto_generated/qgsfeatureiterator.sip"
#include "qgsfeatureiterator.h"
#line 2161 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 44 "core/auto_generated/proj/qgscoordinatetransform.sip"
#include "qgscoordinatetransform.h"
#line 2164 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 26 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qobjectdefs.sip"
#include <qobjectdefs.h>
#line 146 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qobjectdefs.sip"
#include <qobjectdefs.h>
#line 2169 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 26 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qmetaobject.sip"
#include <qmetaobject.h>
#line 2172 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 26 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qcoreevent.sip"
#include <qcoreevent.h>
#line 2175 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 247 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qcoreevent.sip"
#include <qcoreevent.h>
#line 2178 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 235 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qcoreevent.sip"
#include <qcoreevent.h>
#line 2181 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 28 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qobject.sip"
#include <qobject.h>
#line 2184 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 27 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qstring.sip"
#include <qstring.h>
#line 2187 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 26 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qvariant.sip"
#include <qvariant.h>
#line 2190 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 38 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qpycore_qlist.sip"
#include <qlist.h>
#line 2193 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 30 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qbytearray.sip"
#include <qbytearray.h>
#line 2196 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 149 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qpycore_qlist.sip"
#include <qlist.h>
#line 2199 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 26 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 2202 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 26 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qthread.sip"
#include <qthread.h>
#line 2205 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 26 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 2208 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 26 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qregexp.sip"
#include <qregexp.h>
#line 2211 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 26 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qregularexpression.sip"
#include <qregularexpression.h>
#line 2214 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 26 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qobjectdefs.sip"
#include <qobjectdefs.h>
#line 2217 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"


class sipQgsMeshTriangulation : public  ::QgsMeshTriangulation
{
public:
    sipQgsMeshTriangulation();
    virtual ~sipQgsMeshTriangulation();

    int qt_metacall(QMetaObject::Call, int, void **) SIP_OVERRIDE;
    void *qt_metacast(const char *) SIP_OVERRIDE;
    const QMetaObject *metaObject() const SIP_OVERRIDE;

    /*
     * There is a public method for every protected method visible from
     * this class.
     */
     ::QObject* sipProtect_sender() const;
    int sipProtect_receivers(const char*) const;
    void sipProtectVirt_timerEvent(bool, ::QTimerEvent*);
    void sipProtectVirt_childEvent(bool, ::QChildEvent*);
    void sipProtectVirt_customEvent(bool, ::QEvent*);
    void sipProtectVirt_connectNotify(bool,const  ::QMetaMethod&);
    void sipProtectVirt_disconnectNotify(bool,const  ::QMetaMethod&);
    int sipProtect_senderSignalIndex() const;
    bool sipProtect_isSignalConnected(const  ::QMetaMethod&) const;

    /*
     * There is a protected method for every virtual method visible from
     * this class.
     */
protected:
    bool event( ::QEvent*) SIP_OVERRIDE;
    bool eventFilter( ::QObject*, ::QEvent*) SIP_OVERRIDE;
    void timerEvent( ::QTimerEvent*) SIP_OVERRIDE;
    void childEvent( ::QChildEvent*) SIP_OVERRIDE;
    void customEvent( ::QEvent*) SIP_OVERRIDE;
    void connectNotify(const  ::QMetaMethod&) SIP_OVERRIDE;
    void disconnectNotify(const  ::QMetaMethod&) SIP_OVERRIDE;

public:
    sipSimpleWrapper *sipPySelf;

private:
    sipQgsMeshTriangulation(const sipQgsMeshTriangulation &);
    sipQgsMeshTriangulation &operator = (const sipQgsMeshTriangulation &);

    char sipPyMethods[7];
};

sipQgsMeshTriangulation::sipQgsMeshTriangulation():  ::QgsMeshTriangulation(), sipPySelf(SIP_NULLPTR)
{
    memset(sipPyMethods, 0, sizeof (sipPyMethods));
}

sipQgsMeshTriangulation::~sipQgsMeshTriangulation()
{
    sipInstanceDestroyedEx(&sipPySelf);
}

const QMetaObject *sipQgsMeshTriangulation::metaObject() const
{
    if (sipGetInterpreter())
        return QObject::d_ptr->metaObject ? QObject::d_ptr->dynamicMetaObject() : sip__analysis_qt_metaobject(sipPySelf,sipType_QgsMeshTriangulation);

    return  ::QgsMeshTriangulation::metaObject();
}

int sipQgsMeshTriangulation::qt_metacall(QMetaObject::Call _c,int _id,void **_a)
{
    _id =  ::QgsMeshTriangulation::qt_metacall(_c,_id,_a);

    if (_id >= 0)
    {
        SIP_BLOCK_THREADS
        _id = sip__analysis_qt_metacall(sipPySelf,sipType_QgsMeshTriangulation,_c,_id,_a);
        SIP_UNBLOCK_THREADS
    }

    return _id;
}

void *sipQgsMeshTriangulation::qt_metacast(const char *_clname)
{
    void *sipCpp;

    return (sip__analysis_qt_metacast(sipPySelf, sipType_QgsMeshTriangulation, _clname, &sipCpp) ? sipCpp :  ::QgsMeshTriangulation::qt_metacast(_clname));
}

bool sipQgsMeshTriangulation::event( ::QEvent*a0)
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[0],sipPySelf,SIP_NULLPTR,sipName_event);

    if (!sipMeth)
        return  ::QgsMeshTriangulation::event(a0);

    extern bool sipVH__analysis_11(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *,  ::QEvent*);

    return sipVH__analysis_11(sipGILState, sipImportedVirtErrorHandlers__analysis_QtCore[0].iveh_handler, sipPySelf, sipMeth, a0);
}

bool sipQgsMeshTriangulation::eventFilter( ::QObject*a0, ::QEvent*a1)
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[1],sipPySelf,SIP_NULLPTR,sipName_eventFilter);

    if (!sipMeth)
        return  ::QgsMeshTriangulation::eventFilter(a0,a1);

    extern bool sipVH__analysis_10(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *,  ::QObject*, ::QEvent*);

    return sipVH__analysis_10(sipGILState, sipImportedVirtErrorHandlers__analysis_QtCore[0].iveh_handler, sipPySelf, sipMeth, a0, a1);
}

void sipQgsMeshTriangulation::timerEvent( ::QTimerEvent*a0)
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[2],sipPySelf,SIP_NULLPTR,sipName_timerEvent);

    if (!sipMeth)
    {
         ::QgsMeshTriangulation::timerEvent(a0);
        return;
    }

    extern void sipVH__analysis_9(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *,  ::QTimerEvent*);

    sipVH__analysis_9(sipGILState, sipImportedVirtErrorHandlers__analysis_QtCore[0].iveh_handler, sipPySelf, sipMeth, a0);
}

void sipQgsMeshTriangulation::childEvent( ::QChildEvent*a0)
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[3],sipPySelf,SIP_NULLPTR,sipName_childEvent);

    if (!sipMeth)
    {
         ::QgsMeshTriangulation::childEvent(a0);
        return;
    }

    extern void sipVH__analysis_8(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *,  ::QChildEvent*);

    sipVH__analysis_8(sipGILState, sipImportedVirtErrorHandlers__analysis_QtCore[0].iveh_handler, sipPySelf, sipMeth, a0);
}

void sipQgsMeshTriangulation::customEvent( ::QEvent*a0)
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[4],sipPySelf,SIP_NULLPTR,sipName_customEvent);

    if (!sipMeth)
    {
         ::QgsMeshTriangulation::customEvent(a0);
        return;
    }

    extern void sipVH__analysis_7(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *,  ::QEvent*);

    sipVH__analysis_7(sipGILState, sipImportedVirtErrorHandlers__analysis_QtCore[0].iveh_handler, sipPySelf, sipMeth, a0);
}

void sipQgsMeshTriangulation::connectNotify(const  ::QMetaMethod& a0)
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[5],sipPySelf,SIP_NULLPTR,sipName_connectNotify);

    if (!sipMeth)
    {
         ::QgsMeshTriangulation::connectNotify(a0);
        return;
    }

    extern void sipVH__analysis_6(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *, const  ::QMetaMethod&);

    sipVH__analysis_6(sipGILState, sipImportedVirtErrorHandlers__analysis_QtCore[0].iveh_handler, sipPySelf, sipMeth, a0);
}

void sipQgsMeshTriangulation::disconnectNotify(const  ::QMetaMethod& a0)
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[6],sipPySelf,SIP_NULLPTR,sipName_disconnectNotify);

    if (!sipMeth)
    {
         ::QgsMeshTriangulation::disconnectNotify(a0);
        return;
    }

    extern void sipVH__analysis_6(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *, const  ::QMetaMethod&);

    sipVH__analysis_6(sipGILState, sipImportedVirtErrorHandlers__analysis_QtCore[0].iveh_handler, sipPySelf, sipMeth, a0);
}

 ::QObject* sipQgsMeshTriangulation::sipProtect_sender() const
{
    return  ::QObject::sender();
}

int sipQgsMeshTriangulation::sipProtect_receivers(const char*a0) const
{
    return  ::QObject::receivers(a0);
}

void sipQgsMeshTriangulation::sipProtectVirt_timerEvent(bool sipSelfWasArg, ::QTimerEvent*a0)
{
    (sipSelfWasArg ?  ::QObject::timerEvent(a0) : timerEvent(a0));
}

void sipQgsMeshTriangulation::sipProtectVirt_childEvent(bool sipSelfWasArg, ::QChildEvent*a0)
{
    (sipSelfWasArg ?  ::QObject::childEvent(a0) : childEvent(a0));
}

void sipQgsMeshTriangulation::sipProtectVirt_customEvent(bool sipSelfWasArg, ::QEvent*a0)
{
    (sipSelfWasArg ?  ::QObject::customEvent(a0) : customEvent(a0));
}

void sipQgsMeshTriangulation::sipProtectVirt_connectNotify(bool sipSelfWasArg,const  ::QMetaMethod& a0)
{
    (sipSelfWasArg ?  ::QObject::connectNotify(a0) : connectNotify(a0));
}

void sipQgsMeshTriangulation::sipProtectVirt_disconnectNotify(bool sipSelfWasArg,const  ::QMetaMethod& a0)
{
    (sipSelfWasArg ?  ::QObject::disconnectNotify(a0) : disconnectNotify(a0));
}

int sipQgsMeshTriangulation::sipProtect_senderSignalIndex() const
{
    return  ::QObject::senderSignalIndex();
}

bool sipQgsMeshTriangulation::sipProtect_isSignalConnected(const  ::QMetaMethod& a0) const
{
    return  ::QObject::isSignalConnected(a0);
}


PyDoc_STRVAR(doc_QgsMeshTriangulation_sender, "sender(self) -> QObject");

extern "C" {static PyObject *meth_QgsMeshTriangulation_sender(PyObject *, PyObject *);}
static PyObject *meth_QgsMeshTriangulation_sender(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const sipQgsMeshTriangulation *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_QgsMeshTriangulation, &sipCpp))
        {
             ::QObject*sipRes = 0;

#line 570 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qobject.sip"
        // sender() must be called without the GIL to avoid possible deadlocks between
        // the GIL and Qt's internal thread data mutex.
        
        Py_BEGIN_ALLOW_THREADS
        
        #if defined(SIP_PROTECTED_IS_PUBLIC)
        sipRes = sipCpp->sender();
        #else
        sipRes = sipCpp->sipProtect_sender();
        #endif
        
        Py_END_ALLOW_THREADS
        
        if (!sipRes)
        {
            typedef QObject *(*qtcore_qobject_sender_t)();
        
            static qtcore_qobject_sender_t qtcore_qobject_sender = 0;
        
            if (!qtcore_qobject_sender)
            {
                qtcore_qobject_sender = (qtcore_qobject_sender_t)sipImportSymbol("qtcore_qobject_sender");
                Q_ASSERT(qtcore_qobject_sender);
            }
        
            sipRes = qtcore_qobject_sender();
        }
#line 2515 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"

            return sipConvertFromType(sipRes,sipType_QObject,SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshTriangulation, sipName_sender, doc_QgsMeshTriangulation_sender);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsMeshTriangulation_receivers, "receivers(self, PYQT_SIGNAL) -> int");

extern "C" {static PyObject *meth_QgsMeshTriangulation_receivers(PyObject *, PyObject *);}
static PyObject *meth_QgsMeshTriangulation_receivers(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        PyObject * a0;
        const sipQgsMeshTriangulation *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0", &sipSelf, sipType_QgsMeshTriangulation, &sipCpp, &a0))
        {
            int sipRes = 0;
            sipErrorState sipError = sipErrorNone;

#line 601 "/usr/lib64/python3.10/site-packages/PyQt5/bindings/QtCore/qobject.sip"
        // We need to handle the signal object.  Import the helper if it hasn't already
        // been done.
        typedef sipErrorState (*pyqt5_get_signal_signature_t)(PyObject *, const QObject *, const QByteArray &);
        
        static pyqt5_get_signal_signature_t pyqt5_get_signal_signature = 0;
        
        if (!pyqt5_get_signal_signature)
        {
            pyqt5_get_signal_signature = (pyqt5_get_signal_signature_t)sipImportSymbol("pyqt5_get_signal_signature");
            Q_ASSERT(pyqt5_get_signal_signature);
        }
        
        QByteArray signal_signature;
            
        #if defined(SIP_PROTECTED_IS_PUBLIC)
        if ((sipError = pyqt5_get_signal_signature(a0, sipCpp, signal_signature)) == sipErrorNone)
        {
            sipRes = sipCpp->receivers(signal_signature.constData());
        }
        #else
        if ((sipError = pyqt5_get_signal_signature(a0, static_cast<const QObject *>(sipCpp), signal_signature)) == sipErrorNone)
        {
            sipRes = sipCpp->sipProtect_receivers(signal_signature.constData());
        }
        #endif
        else if (sipError == sipErrorContinue)
        {
            sipError = sipBadCallableArg(0, a0);
        }
#line 2574 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"

            if (sipError == sipErrorFail)
                return 0;

            if (sipError == sipErrorNone)
            {
            return SIPLong_FromLong(sipRes);
            }

            sipAddException(sipError, &sipParseErr);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshTriangulation, sipName_receivers, doc_QgsMeshTriangulation_receivers);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsMeshTriangulation_timerEvent, "timerEvent(self, QTimerEvent)");

extern "C" {static PyObject *meth_QgsMeshTriangulation_timerEvent(PyObject *, PyObject *);}
static PyObject *meth_QgsMeshTriangulation_timerEvent(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;
    bool sipSelfWasArg = (!sipSelf || sipIsDerivedClass((sipSimpleWrapper *)sipSelf));

    {
         ::QTimerEvent* a0;
        sipQgsMeshTriangulation *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8", &sipSelf, sipType_QgsMeshTriangulation, &sipCpp, sipType_QTimerEvent, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipCpp->sipProtectVirt_timerEvent(sipSelfWasArg,a0);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshTriangulation, sipName_timerEvent, doc_QgsMeshTriangulation_timerEvent);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsMeshTriangulation_childEvent, "childEvent(self, QChildEvent)");

extern "C" {static PyObject *meth_QgsMeshTriangulation_childEvent(PyObject *, PyObject *);}
static PyObject *meth_QgsMeshTriangulation_childEvent(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;
    bool sipSelfWasArg = (!sipSelf || sipIsDerivedClass((sipSimpleWrapper *)sipSelf));

    {
         ::QChildEvent* a0;
        sipQgsMeshTriangulation *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8", &sipSelf, sipType_QgsMeshTriangulation, &sipCpp, sipType_QChildEvent, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipCpp->sipProtectVirt_childEvent(sipSelfWasArg,a0);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshTriangulation, sipName_childEvent, doc_QgsMeshTriangulation_childEvent);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsMeshTriangulation_customEvent, "customEvent(self, QEvent)");

extern "C" {static PyObject *meth_QgsMeshTriangulation_customEvent(PyObject *, PyObject *);}
static PyObject *meth_QgsMeshTriangulation_customEvent(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;
    bool sipSelfWasArg = (!sipSelf || sipIsDerivedClass((sipSimpleWrapper *)sipSelf));

    {
         ::QEvent* a0;
        sipQgsMeshTriangulation *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8", &sipSelf, sipType_QgsMeshTriangulation, &sipCpp, sipType_QEvent, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipCpp->sipProtectVirt_customEvent(sipSelfWasArg,a0);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshTriangulation, sipName_customEvent, doc_QgsMeshTriangulation_customEvent);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsMeshTriangulation_connectNotify, "connectNotify(self, QMetaMethod)");

extern "C" {static PyObject *meth_QgsMeshTriangulation_connectNotify(PyObject *, PyObject *);}
static PyObject *meth_QgsMeshTriangulation_connectNotify(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;
    bool sipSelfWasArg = (!sipSelf || sipIsDerivedClass((sipSimpleWrapper *)sipSelf));

    {
        const  ::QMetaMethod* a0;
        sipQgsMeshTriangulation *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ9", &sipSelf, sipType_QgsMeshTriangulation, &sipCpp, sipType_QMetaMethod, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipCpp->sipProtectVirt_connectNotify(sipSelfWasArg,*a0);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshTriangulation, sipName_connectNotify, doc_QgsMeshTriangulation_connectNotify);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsMeshTriangulation_disconnectNotify, "disconnectNotify(self, QMetaMethod)");

extern "C" {static PyObject *meth_QgsMeshTriangulation_disconnectNotify(PyObject *, PyObject *);}
static PyObject *meth_QgsMeshTriangulation_disconnectNotify(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;
    bool sipSelfWasArg = (!sipSelf || sipIsDerivedClass((sipSimpleWrapper *)sipSelf));

    {
        const  ::QMetaMethod* a0;
        sipQgsMeshTriangulation *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ9", &sipSelf, sipType_QgsMeshTriangulation, &sipCpp, sipType_QMetaMethod, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipCpp->sipProtectVirt_disconnectNotify(sipSelfWasArg,*a0);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshTriangulation, sipName_disconnectNotify, doc_QgsMeshTriangulation_disconnectNotify);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsMeshTriangulation_senderSignalIndex, "senderSignalIndex(self) -> int");

extern "C" {static PyObject *meth_QgsMeshTriangulation_senderSignalIndex(PyObject *, PyObject *);}
static PyObject *meth_QgsMeshTriangulation_senderSignalIndex(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const sipQgsMeshTriangulation *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_QgsMeshTriangulation, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = sipCpp->sipProtect_senderSignalIndex();
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshTriangulation, sipName_senderSignalIndex, doc_QgsMeshTriangulation_senderSignalIndex);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsMeshTriangulation_isSignalConnected, "isSignalConnected(self, QMetaMethod) -> bool");

extern "C" {static PyObject *meth_QgsMeshTriangulation_isSignalConnected(PyObject *, PyObject *);}
static PyObject *meth_QgsMeshTriangulation_isSignalConnected(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const  ::QMetaMethod* a0;
        const sipQgsMeshTriangulation *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ9", &sipSelf, sipType_QgsMeshTriangulation, &sipCpp, sipType_QMetaMethod, &a0))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = sipCpp->sipProtect_isSignalConnected(*a0);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return PyBool_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshTriangulation, sipName_isSignalConnected, doc_QgsMeshTriangulation_isSignalConnected);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsMeshTriangulation_addVertices, "addVertices(self, vertexFeatureIterator: QgsFeatureIterator, valueAttribute: int, transform: QgsCoordinateTransform, feedback: QgsFeedback = None, featureCount: int = 1) -> bool\n"
"Adds vertices to the triangulation from a feature iterator, return ``True`` if successful.\n"
"\n"
":param vertexFeatureIterator: the feature iterator of vertices to insert\n"
":param valueAttribute: the index of the attribute that represents the value of vertices, if -1 uses Z coordinate of vertices\n"
":param transform: the coordinates transform used to transform coordinates\n"
":param feedback: feedback argument may be specified to allow cancellation and progress reports\n"
":param featureCount: the count of feature to allow progress report of the feedback");

extern "C" {static PyObject *meth_QgsMeshTriangulation_addVertices(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_QgsMeshTriangulation_addVertices(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
         ::QgsFeatureIterator* a0;
        int a1;
        const  ::QgsCoordinateTransform* a2;
         ::QgsFeedback* a3 = 0;
        long a4 = 1;
         ::QgsMeshTriangulation *sipCpp;

        static const char *sipKwdList[] = {
            sipName_vertexFeatureIterator,
            sipName_valueAttribute,
            sipName_transform,
            sipName_feedback,
            sipName_featureCount,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "BJ9iJ9|J8l", &sipSelf, sipType_QgsMeshTriangulation, &sipCpp, sipType_QgsFeatureIterator, &a0, &a1, sipType_QgsCoordinateTransform, &a2, sipType_QgsFeedback, &a3, &a4))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = sipCpp->addVertices(*a0,a1,*a2,a3,a4);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return PyBool_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshTriangulation, sipName_addVertices, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsMeshTriangulation_addBreakLines, "addBreakLines(self, lineFeatureIterator: QgsFeatureIterator, valueAttribute: int, transformContext: QgsCoordinateTransform, feedback: QgsFeedback = None, featureCount: int = 1) -> bool\n"
"Adds break lines from a vector layer, return ``True`` if successful.\n"
"\n"
":param lineFeatureIterator: the feature iterator of break lines to insert\n"
":param valueAttribute: the index of the attribute that represents the value of vertices, if -1 uses Z coordinate of vertices\n"
":param transformContext: the coordinates transform context used to transform coordinates\n"
":param feedback: feedback argument may be specified to allow cancellation and progress reports\n"
":param featureCount: the count of feature to allow progress report of the feedback\n"
"\n"
".. warning::\n"
"\n"
"   if the feature iterator contains only point geometries, the vertices will be added only without treating them as breaklines");

extern "C" {static PyObject *meth_QgsMeshTriangulation_addBreakLines(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_QgsMeshTriangulation_addBreakLines(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
         ::QgsFeatureIterator* a0;
        int a1;
        const  ::QgsCoordinateTransform* a2;
         ::QgsFeedback* a3 = 0;
        long a4 = 1;
         ::QgsMeshTriangulation *sipCpp;

        static const char *sipKwdList[] = {
            sipName_lineFeatureIterator,
            sipName_valueAttribute,
            sipName_transformContext,
            sipName_feedback,
            sipName_featureCount,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "BJ9iJ9|J8l", &sipSelf, sipType_QgsMeshTriangulation, &sipCpp, sipType_QgsFeatureIterator, &a0, &a1, sipType_QgsCoordinateTransform, &a2, sipType_QgsFeedback, &a3, &a4))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = sipCpp->addBreakLines(*a0,a1,*a2,a3,a4);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return PyBool_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshTriangulation, sipName_addBreakLines, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsMeshTriangulation_triangulatedMesh, "triangulatedMesh(self, feedback: QgsFeedback = None) -> QgsMesh\n"
"Returns the triangulated mesh");

extern "C" {static PyObject *meth_QgsMeshTriangulation_triangulatedMesh(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_QgsMeshTriangulation_triangulatedMesh(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
         ::QgsFeedback* a0 = 0;
        const  ::QgsMeshTriangulation *sipCpp;

        static const char *sipKwdList[] = {
            sipName_feedback,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "B|J8", &sipSelf, sipType_QgsMeshTriangulation, &sipCpp, sipType_QgsFeedback, &a0))
        {
             ::QgsMesh*sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = new  ::QgsMesh(sipCpp->triangulatedMesh(a0));
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QgsMesh,SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshTriangulation, sipName_triangulatedMesh, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsMeshTriangulation_setCrs, "setCrs(self, crs: QgsCoordinateReferenceSystem)\n"
"Sets the coordinate reference system used for the triangulation");

extern "C" {static PyObject *meth_QgsMeshTriangulation_setCrs(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_QgsMeshTriangulation_setCrs(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const  ::QgsCoordinateReferenceSystem* a0;
         ::QgsMeshTriangulation *sipCpp;

        static const char *sipKwdList[] = {
            sipName_crs,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "BJ9", &sipSelf, sipType_QgsMeshTriangulation, &sipCpp, sipType_QgsCoordinateReferenceSystem, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipCpp->setCrs(*a0);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshTriangulation, sipName_setCrs, SIP_NULLPTR);

    return SIP_NULLPTR;
}


/* Cast a pointer to a type somewhere in its inheritance hierarchy. */
extern "C" {static void *cast_QgsMeshTriangulation(void *, const sipTypeDef *);}
static void *cast_QgsMeshTriangulation(void *sipCppV, const sipTypeDef *targetType)
{
     ::QgsMeshTriangulation *sipCpp = reinterpret_cast< ::QgsMeshTriangulation *>(sipCppV);

    if (targetType == sipType_QObject)
        return static_cast< ::QObject *>(sipCpp);

    return sipCppV;
}


/* Call the instance's destructor. */
extern "C" {static void release_QgsMeshTriangulation(void *, int);}
static void release_QgsMeshTriangulation(void *sipCppV, int)
{
     ::QgsMeshTriangulation *sipCpp = reinterpret_cast< ::QgsMeshTriangulation *>(sipCppV);

    Py_BEGIN_ALLOW_THREADS

    if (QThread::currentThread() == sipCpp->thread())
        delete sipCpp;
    else
        sipCpp->deleteLater();

    Py_END_ALLOW_THREADS
}


extern "C" {static void *array_QgsMeshTriangulation(Py_ssize_t);}
static void *array_QgsMeshTriangulation(Py_ssize_t sipNrElem)
{
    return new  ::QgsMeshTriangulation[sipNrElem];
}


extern "C" {static void dealloc_QgsMeshTriangulation(sipSimpleWrapper *);}
static void dealloc_QgsMeshTriangulation(sipSimpleWrapper *sipSelf)
{
    if (sipIsDerivedClass(sipSelf))
        reinterpret_cast<sipQgsMeshTriangulation *>(sipGetAddress(sipSelf))->sipPySelf = SIP_NULLPTR;

    if (sipIsOwnedByPython(sipSelf))
    {
        release_QgsMeshTriangulation(sipGetAddress(sipSelf), sipIsDerivedClass(sipSelf));
    }
}


extern "C" {static void *init_type_QgsMeshTriangulation(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_QgsMeshTriangulation(sipSimpleWrapper *sipSelf, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    sipQgsMeshTriangulation *sipCpp = SIP_NULLPTR;

    {
        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, SIP_NULLPTR, sipUnused, ""))
        {
            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipCpp = new sipQgsMeshTriangulation();
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    return SIP_NULLPTR;
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_QgsMeshTriangulation[] = {{9, 0, 1}};


static PyMethodDef methods_QgsMeshTriangulation[] = {
    {SIP_MLNAME_CAST(sipName_addBreakLines), SIP_MLMETH_CAST(meth_QgsMeshTriangulation_addBreakLines), METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_QgsMeshTriangulation_addBreakLines)},
    {SIP_MLNAME_CAST(sipName_addVertices), SIP_MLMETH_CAST(meth_QgsMeshTriangulation_addVertices), METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_QgsMeshTriangulation_addVertices)},
    {SIP_MLNAME_CAST(sipName_childEvent), meth_QgsMeshTriangulation_childEvent, METH_VARARGS, SIP_NULLPTR},
    {SIP_MLNAME_CAST(sipName_connectNotify), meth_QgsMeshTriangulation_connectNotify, METH_VARARGS, SIP_NULLPTR},
    {SIP_MLNAME_CAST(sipName_customEvent), meth_QgsMeshTriangulation_customEvent, METH_VARARGS, SIP_NULLPTR},
    {SIP_MLNAME_CAST(sipName_disconnectNotify), meth_QgsMeshTriangulation_disconnectNotify, METH_VARARGS, SIP_NULLPTR},
    {SIP_MLNAME_CAST(sipName_isSignalConnected), meth_QgsMeshTriangulation_isSignalConnected, METH_VARARGS, SIP_NULLPTR},
    {SIP_MLNAME_CAST(sipName_receivers), meth_QgsMeshTriangulation_receivers, METH_VARARGS, SIP_NULLPTR},
    {SIP_MLNAME_CAST(sipName_sender), meth_QgsMeshTriangulation_sender, METH_VARARGS, SIP_NULLPTR},
    {SIP_MLNAME_CAST(sipName_senderSignalIndex), meth_QgsMeshTriangulation_senderSignalIndex, METH_VARARGS, SIP_NULLPTR},
    {SIP_MLNAME_CAST(sipName_setCrs), SIP_MLMETH_CAST(meth_QgsMeshTriangulation_setCrs), METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_QgsMeshTriangulation_setCrs)},
    {SIP_MLNAME_CAST(sipName_timerEvent), meth_QgsMeshTriangulation_timerEvent, METH_VARARGS, SIP_NULLPTR},
    {SIP_MLNAME_CAST(sipName_triangulatedMesh), SIP_MLMETH_CAST(meth_QgsMeshTriangulation_triangulatedMesh), METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_QgsMeshTriangulation_triangulatedMesh)}
};

PyDoc_STRVAR(doc_QgsMeshTriangulation, "\n"
"Class that handles mesh creation with Delaunay constrained triangulation\n"
"\n"
".. versionadded:: 3.16\n"
"\n"
"QgsMeshTriangulation()\n"
"Constructor");


static pyqt5ClassPluginDef plugin_QgsMeshTriangulation = {
    & ::QgsMeshTriangulation::staticMetaObject,
    0,
    SIP_NULLPTR,
    SIP_NULLPTR
};


sipClassTypeDef sipTypeDef__analysis_QgsMeshTriangulation = {
    {
        -1,
        SIP_NULLPTR,
        SIP_NULLPTR,
        SIP_TYPE_SCC|SIP_TYPE_SUPER_INIT|SIP_TYPE_CLASS,
        sipNameNr_QgsMeshTriangulation,
        {SIP_NULLPTR},
        &plugin_QgsMeshTriangulation
    },
    {
        sipNameNr_QgsMeshTriangulation,
        {0, 0, 1},
        13, methods_QgsMeshTriangulation,
        0, SIP_NULLPTR,
        0, SIP_NULLPTR,
        {SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR},
    },
    doc_QgsMeshTriangulation,
    -1,
    -1,
    supers_QgsMeshTriangulation,
    SIP_NULLPTR,
    init_type_QgsMeshTriangulation,
    SIP_NULLPTR,
    SIP_NULLPTR,
#if PY_MAJOR_VERSION >= 3
    SIP_NULLPTR,
    SIP_NULLPTR,
#else
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
#endif
    dealloc_QgsMeshTriangulation,
    SIP_NULLPTR,
    array_QgsMeshTriangulation,
    SIP_NULLPTR,
    release_QgsMeshTriangulation,
    cast_QgsMeshTriangulation,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR
};

#line 24 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/auto_generated/mesh/qgsmeshcontours.sip"
#include "qgsmeshcontours.h"
#line 3255 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"

#line 79 "core/auto_generated/mesh/qgsmeshlayer.sip"
#include "qgsmeshlayer.h"
#line 3259 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 57 "core/auto_generated/geometry/qgsgeometry.sip"
#include "qgsgeometry.h"
#line 3262 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 30 "core/auto_generated/mesh/qgsmeshdataset.sip"
#include "qgsmeshdataset.h"
#line 3265 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 96 "core/auto_generated/mesh/qgsmeshrenderersettings.sip"
#include "qgsmeshrenderersettings.h"
#line 3268 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"
#line 35 "core/auto_generated/qgsfeedback.sip"
#include "qgsfeedback.h"
#line 3271 "/builddir/build/BUILD/qgis-3.20.3/redhat-linux-build/python/analysis/sip_analysispart9.cpp"


PyDoc_STRVAR(doc_QgsMeshContours_exportLines, "exportLines(self, index: QgsMeshDatasetIndex, value: float, method: QgsMeshRendererScalarSettings.DataResamplingMethod, feedback: QgsFeedback = None) -> QgsGeometry\n"
"Exports multi line string containing the contour line for particular dataset and value.\n"
"\n"
":param index: dataset index that is used to update the cache\n"
":param value: value of the contour line\n"
":param method: for datasets defined on faces, the method will be used to convert data to vertices\n"
":param feedback: optional feedback object for progress and cancellation support\n"
"\n"
":return: MultiLineString geometry containing contour lines\n"
"\n"
".. note::\n"
"\n"
"   not thread safe");

extern "C" {static PyObject *meth_QgsMeshContours_exportLines(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_QgsMeshContours_exportLines(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const  ::QgsMeshDatasetIndex* a0;
        double a1;
         ::QgsMeshRendererScalarSettings::DataResamplingMethod a2;
         ::QgsFeedback* a3 = 0;
         ::QgsMeshContours *sipCpp;

        static const char *sipKwdList[] = {
            sipName_index,
            sipName_value,
            sipName_method,
            sipName_feedback,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "BJ9dE|J8", &sipSelf, sipType_QgsMeshContours, &sipCpp, sipType_QgsMeshDatasetIndex, &a0, &a1, sipType_QgsMeshRendererScalarSettings_DataResamplingMethod, &a2, sipType_QgsFeedback, &a3))
        {
             ::QgsGeometry*sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = new  ::QgsGeometry(sipCpp->exportLines(*a0,a1,a2,a3));
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QgsGeometry,SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshContours, sipName_exportLines, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_QgsMeshContours_exportPolygons, "exportPolygons(self, index: QgsMeshDatasetIndex, min_value: float, max_value: float, method: QgsMeshRendererScalarSettings.DataResamplingMethod, feedback: QgsFeedback = None) -> QgsGeometry\n"
"Exports multi polygons representing the areas with values in range for particular dataset\n"
"\n"
":param index: dataset index\n"
":param min_value: minimum of the value interval for contour polygon\n"
":param max_value: maximum of the value interval for contour polygon\n"
":param method: for datasets defined on faces, the method will be used to convert data to vertices\n"
":param feedback: optional feedback object for progress and cancellation support\n"
"\n"
":return: MultiPolygon geometry containing contour polygons\n"
"\n"
".. note::\n"
"\n"
"   not thread safe");

extern "C" {static PyObject *meth_QgsMeshContours_exportPolygons(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_QgsMeshContours_exportPolygons(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const  ::QgsMeshDatasetIndex* a0;
        double a1;
        double a2;
         ::QgsMeshRendererScalarSettings::DataResamplingMethod a3;
         ::QgsFeedback* a4 = 0;
         ::QgsMeshContours *sipCpp;

        static const char *sipKwdList[] = {
            sipName_index,
            sipName_min_value,
            sipName_max_value,
            sipName_method,
            sipName_feedback,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "BJ9ddE|J8", &sipSelf, sipType_QgsMeshContours, &sipCpp, sipType_QgsMeshDatasetIndex, &a0, &a1, &a2, sipType_QgsMeshRendererScalarSettings_DataResamplingMethod, &a3, sipType_QgsFeedback, &a4))
        {
             ::QgsGeometry*sipRes;

            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipRes = new  ::QgsGeometry(sipCpp->exportPolygons(*a0,a1,a2,a3,a4));
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QgsGeometry,SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_QgsMeshContours, sipName_exportPolygons, SIP_NULLPTR);

    return SIP_NULLPTR;
}


/* Call the instance's destructor. */
extern "C" {static void release_QgsMeshContours(void *, int);}
static void release_QgsMeshContours(void *sipCppV, int)
{
    Py_BEGIN_ALLOW_THREADS

    delete reinterpret_cast< ::QgsMeshContours *>(sipCppV);

    Py_END_ALLOW_THREADS
}


extern "C" {static void assign_QgsMeshContours(void *, SIP_SSIZE_T, void *);}
static void assign_QgsMeshContours(void *sipDst, SIP_SSIZE_T sipDstIdx, void *sipSrc)
{
    reinterpret_cast< ::QgsMeshContours *>(sipDst)[sipDstIdx] = *reinterpret_cast< ::QgsMeshContours *>(sipSrc);
}


extern "C" {static void *copy_QgsMeshContours(const void *, SIP_SSIZE_T);}
static void *copy_QgsMeshContours(const void *sipSrc, SIP_SSIZE_T sipSrcIdx)
{
    return new  ::QgsMeshContours(reinterpret_cast<const  ::QgsMeshContours *>(sipSrc)[sipSrcIdx]);
}


extern "C" {static void dealloc_QgsMeshContours(sipSimpleWrapper *);}
static void dealloc_QgsMeshContours(sipSimpleWrapper *sipSelf)
{
    if (sipIsOwnedByPython(sipSelf))
    {
        release_QgsMeshContours(sipGetAddress(sipSelf), 0);
    }
}


extern "C" {static void *init_type_QgsMeshContours(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_QgsMeshContours(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
     ::QgsMeshContours *sipCpp = SIP_NULLPTR;

    {
         ::QgsMeshLayer* a0;

        static const char *sipKwdList[] = {
            sipName_layer,
        };

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, sipKwdList, sipUnused, "J8", sipType_QgsMeshLayer, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipCpp = new  ::QgsMeshContours(a0);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipCpp;
        }
    }

    {
        const  ::QgsMeshContours* a0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, SIP_NULLPTR, sipUnused, "J9", sipType_QgsMeshContours, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            try
            {
            sipCpp = new  ::QgsMeshContours(*a0);
            }
            catch (...)
            {
                Py_BLOCK_THREADS

                sipRaiseUnknownException();
                return SIP_NULLPTR;
            }
            Py_END_ALLOW_THREADS

            return sipCpp;
        }
    }

    return SIP_NULLPTR;
}


static PyMethodDef methods_QgsMeshContours[] = {
    {SIP_MLNAME_CAST(sipName_exportLines), SIP_MLMETH_CAST(meth_QgsMeshContours_exportLines), METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_QgsMeshContours_exportLines)},
    {SIP_MLNAME_CAST(sipName_exportPolygons), SIP_MLMETH_CAST(meth_QgsMeshContours_exportPolygons), METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_QgsMeshContours_exportPolygons)}
};

PyDoc_STRVAR(doc_QgsMeshContours, "\n"
"Exporter of contours lines or polygons from a mesh layer.\n"
"\n"
".. versionadded:: 3.12\n"
"\n"
"QgsMeshContours(layer: QgsMeshLayer)\n"
"Constructs the mesh contours exporter.\n"
"Caches the native and triangular mesh from data provider\n"
"\n"
":param layer: mesh layer to be associated with this exporter\n"
"\n"
"QgsMeshContours(QgsMeshContours)");


static pyqt5ClassPluginDef plugin_QgsMeshContours = {
    SIP_NULLPTR,
    0,
    SIP_NULLPTR,
    SIP_NULLPTR
};


sipClassTypeDef sipTypeDef__analysis_QgsMeshContours = {
    {
        -1,
        SIP_NULLPTR,
        SIP_NULLPTR,
        SIP_TYPE_SUPER_INIT|SIP_TYPE_CLASS,
        sipNameNr_QgsMeshContours,
        {SIP_NULLPTR},
        &plugin_QgsMeshContours
    },
    {
        sipNameNr_QgsMeshContours,
        {0, 0, 1},
        2, methods_QgsMeshContours,
        0, SIP_NULLPTR,
        0, SIP_NULLPTR,
        {SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR},
    },
    doc_QgsMeshContours,
    -1,
    -1,
    SIP_NULLPTR,
    SIP_NULLPTR,
    init_type_QgsMeshContours,
    SIP_NULLPTR,
    SIP_NULLPTR,
#if PY_MAJOR_VERSION >= 3
    SIP_NULLPTR,
    SIP_NULLPTR,
#else
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
#endif
    dealloc_QgsMeshContours,
    assign_QgsMeshContours,
    SIP_NULLPTR,
    copy_QgsMeshContours,
    release_QgsMeshContours,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR
};
